--- lrb_prototype_primitives.inl	2010-06-15 17:01:51.147217886 +0200
+++ lrbni_prototypes.h	2010-06-15 17:01:22.767217213 +0200
@@ -7477,10 +7501,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = p2[i] - (p1[i] * p3[i]);
@@ -7504,10 +7528,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7541,10 +7565,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] - (p1[i] * p3[i]);
@@ -7568,10 +7592,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7605,10 +7629,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = p3[i] - (p2[i] * p1[i]);
@@ -7632,10 +7656,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7669,10 +7693,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p3[i] - (p2[i] * p1[i]);
@@ -7696,10 +7720,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7733,10 +7757,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = p1[i] - (p2[i] * p3[i]);
@@ -7760,10 +7784,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7797,10 +7821,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p1[i] - (p2[i] * p3[i]);
@@ -7824,10 +7848,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7861,9 +7885,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = 1.0 - (p2[i] * p3[i]);
@@ -7887,10 +7911,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7925,9 +7949,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = 1.0f - (p2[i] * p3[i]);
@@ -7945,16 +7969,16 @@
     return result;
 }
 
-/* Multiply float32 vectors and substract from 1 under mask. */
+/* Multiply float32 vectors and subtract from 1 under mask. */
 inline _M512 _mm512_mask_msubr23c1_ps(_M512 v1_old, __mmask k1, _M512 v2, _M512 v3)
 {
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7988,9 +8012,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         int64_t tmp = p2[i] * p3[i];
@@ -8004,10 +8028,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8026,9 +8050,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         uint64_t tmp = p2[i] * p3[i];
@@ -8042,10 +8066,10 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8064,9 +8088,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         int64_t tmp = p2[i] * p3[i];
@@ -8080,10 +8104,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8103,9 +8127,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = p2[i] * p3[i];
@@ -8128,10 +8152,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -8165,9 +8189,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] * p3[i];
@@ -8190,10 +8214,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8227,9 +8251,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] | p3[i];
@@ -8252,10 +8276,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8295,10 +8319,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
-    int64_t *p1 = (int64_t *) &v1_old;
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *p3 = (int64_t *) &v3;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p1 = (_LPP_Int64 *) &v1_old;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *p3 = (_LPP_Int64 *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -8329,27 +8353,27 @@
 /* Compress and store unaligned from doubleword vector. */
 inline void _mm512_compressd(void *m, _M512 v2, _MM_DOWNCONV32_ENUM down_conv, _MM_MEM_HINT_ENUM)
 {
-    int *p2 = (int *) &v2;
-    char *dstB;
-    short *dstW;
-    int *dstD;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Char *dstB;
+    _LPP_Short *dstW;
+    _LPP_Int *dstD;
     int size = _LPP_DownConvSize(down_conv);
 
     switch(size) {
         case 1:
-            dstB = (char *) m;
+            dstB = (_LPP_Char *) m;
             for (int i=0; i < 16; i++) {
                 *dstB++ = _LPP_DownConvByte(p2[i], down_conv);
             }
         break;
         case 2:
-            dstW = (short *) m;
+            dstW = (_LPP_Short *) m;
             for (int i=0; i < 16; i++) {
                 *dstW++ = _LPP_DownConvWord(p2[i], down_conv);
             }
         break;
         case 4:
-            dstD = (int *) m;
+            dstD = (_LPP_Int *) m;
             for (int i=0; i < 16; i++) {
                 *dstD++ = p2[i];
             }
@@ -8360,15 +8384,15 @@
 /* Compress and store unaligned from doubleword vector under mask. */
 inline void _mm512_mask_compressd(void *m, __mmask k1, _M512 v2, _MM_DOWNCONV32_ENUM down_conv, _MM_MEM_HINT_ENUM)
 {
-    int *p2 = (int *) &v2;
-    char *dstB;
-    short *dstW;
-    int *dstD;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Char *dstB;
+    _LPP_Short *dstW;
+    _LPP_Int *dstD;
     int size = _LPP_DownConvSize(down_conv);
 
     switch(size) {
         case 1:
-            dstB = (char *) m;
+            dstB = (_LPP_Char *) m;
             for (int i=0; i < 16; i++) {
                 if (k1 & 1) {
                     *dstB++ = _LPP_DownConvByte(p2[i], down_conv);
@@ -8377,7 +8401,7 @@
             }
         break;
         case 2:
-            dstW = (short *) m;
+            dstW = (_LPP_Short *) m;
             for (int i=0; i < 16; i++) {
                 if (k1 & 1) {
                     *dstW++ = _LPP_DownConvWord(p2[i], down_conv);
@@ -8386,7 +8410,7 @@
             }
         break;
         case 4:
-            dstD = (int *) m;
+            dstD = (_LPP_Int *) m;
             for (int i=0; i < 16; i++) {
                 if (k1 & 1) {
                     *dstD++ = p2[i];
@@ -8400,10 +8424,10 @@
 /* Compress and store unaligned from quadword vector. */
 inline void _mm512_compressq(void *m, _M512 v2, _MM_DOWNCONV64_ENUM, _MM_MEM_HINT_ENUM)
 {
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *dst = (int64_t *) m;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *dst = (_LPP_Int64 *) m;
 
-    for (int i=0; i < 16; i++) {
+    for (int i=0; i < 8; i++) {
         *dst++ = p2[i];
     }
 }
@@ -8411,10 +8435,10 @@
 /* Compress and store unaligned from quadword vector under mask. */
 inline void _mm512_mask_compressq(void *m, __mmask k1, _M512 v2, _MM_DOWNCONV64_ENUM, _MM_MEM_HINT_ENUM)
 {
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *dst = (int64_t *) m;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *dst = (_LPP_Int64 *) m;
 
-    for (int i=0; i < 16; i++) {
+    for (int i=0; i < 8; i++) {
         if (k1 & 1) {
             *dst++ = p2[i];
         }
@@ -8426,8 +8450,8 @@
 inline _M512I _mm512_rotatefield_pi(_M512I v2, _MM_BITPOSITION32_ENUM rotation, _MM_BITPOSITION32_ENUM bit_idx_low, _MM_BITPOSITION32_ENUM bit_idx_high)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int maskRight = 0xFFFFFFFF >> (31 - bit_idx_high);
     unsigned int maskLeft = 0xFFFFFFFF << bit_idx_low;
     unsigned int mask;
@@ -8449,9 +8473,9 @@
 inline _M512I _mm512_mask_rotatefield_pi(_M512I v1_old, __mmask k1, _M512I v2, _MM_BITPOSITION32_ENUM rotation, _MM_BITPOSITION32_ENUM bit_idx_low, _MM_BITPOSITION32_ENUM bit_idx_high)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int maskRight = 0xFFFFFFFF >> (31 - bit_idx_high);
     unsigned int maskLeft = 0xFFFFFFFF << bit_idx_low;
     unsigned int mask;
@@ -8480,8 +8504,8 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = (float) _LPP_ConvertFloat32ToInt32(p2[i], rc, expadj);
@@ -8512,9 +8536,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8556,9 +8580,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p1[i] - p3[i] - (k2 & 1);
@@ -8576,9 +8600,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8602,9 +8626,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p3[i] - p1[i] - (k2 & 1);
@@ -8622,9 +8646,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8647,9 +8671,9 @@
 {
     _M512 result;
 
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] * pow(2.0f, p3[i]);
@@ -8662,10 +8686,10 @@
 {
     _M512 result;
 
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8681,9 +8705,9 @@
 /* Scatter element vector. */
 inline void _mm512_scatterd(void *m, _M512I index, _M512 v1, _MM_DOWNCONV32_ENUM down_conv, _MM_INDEX_SCALE_ENUM scale, _MM_MEM_HINT_ENUM)
 {
-    int *p1 = (int *) &v1;
-    int *idx = (int *) &index;
-    char *dst = (char *) m;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *idx = (_LPP_Int *) &index;
+    _LPP_Char *dst = (_LPP_Char *) m;
     int size = _LPP_DownConvSize(down_conv);
 
     switch(size) {
@@ -8694,12 +8718,12 @@
         break;
         case 2:
             for (int i=0; i < 16; i++) {
-                *((short *) (dst + idx[i]*scale)) = _LPP_DownConvWord(p1[i], down_conv);
+                *((_LPP_Short *) (dst + idx[i]*scale)) = _LPP_DownConvWord(p1[i], down_conv);
             }
         break;
         case 4:
             for (int i=0; i < 16; i++) {
-                *((int *) (dst + idx[i]*scale)) = p1[i];
+                *((_LPP_Int *) (dst + idx[i]*scale)) = p1[i];
             }
         break;
     }
@@ -8708,9 +8732,9 @@
 /* Scatter element vector under mask. */
 inline void _mm512_mask_scatterd(void *m, __mmask k1, _M512I index, _M512 v1, _MM_DOWNCONV32_ENUM down_conv, _MM_INDEX_SCALE_ENUM scale, _MM_MEM_HINT_ENUM)
 {
-    int *p1 = (int *) &v1;
-    int *idx = (int *) &index;
-    char *dst = (char *) m;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *idx = (_LPP_Int *) &index;
+    _LPP_Char *dst = (_LPP_Char *) m;
     int size = _LPP_DownConvSize(down_conv);
 
     switch(size) {
@@ -8725,7 +8749,7 @@
         case 2:
             for (int i=0; i < 16; i++) {
                 if (k1 & 1) {
-                    *((short *) (dst + idx[i]*scale)) = _LPP_DownConvWord(p1[i], down_conv);
+                    *((_LPP_Short *) (dst + idx[i]*scale)) = _LPP_DownConvWord(p1[i], down_conv);
                 }
                 k1 >>= 1;
             }
@@ -8733,7 +8757,7 @@
         case 4:
             for (int i=0; i < 16; i++) {
                 if (k1 & 1) {
-                    *((int *) (dst + idx[i]*scale)) = p1[i];
+                    *((_LPP_Int *) (dst + idx[i]*scale)) = p1[i];
                 }
                 k1 >>= 1;
             }
@@ -8758,8 +8782,8 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
     int lanePerm = perm128;
 
     for (int i=0; i < 4; i++) {
@@ -8778,9 +8802,9 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
     int lanePerm = perm128;
 
     for (int i=0; i < 4; i++) {
@@ -8804,8 +8828,8 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *src = (int *) m;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *src = (_LPP_Int *) m;
     int lanePerm = perm128;
 
     for (int i=0; i < 4; i++) {
@@ -8824,9 +8848,9 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *src = (int *) m;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *src = (_LPP_Int *) m;
     int lanePerm = perm128;
 
     for (int i=0; i < 4; i++) {
@@ -8850,9 +8874,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] << (p3[i] & 0x1F);
@@ -8865,10 +8889,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8886,9 +8910,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] >> (p3[i] & 0x1F);
@@ -8901,10 +8925,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8922,9 +8946,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] >> (p3[i] & 0x1F);
@@ -8937,10 +8961,10 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -8956,10 +8980,10 @@
 /* Store doubleword vector. */
 inline void _mm512_stored(void *m, _M512 v2, _MM_DOWNCONV32_ENUM down_conv, _MM_STORE_SUBSET32_ENUM subset, _MM_MEM_HINT_ENUM)
 {
-    int *p2 = (int *) &v2;
-    char *dstB;
-    short *dstW;
-    int *dstD;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Char *dstB;
+    _LPP_Short *dstW;
+    _LPP_Int *dstD;
     int size = _LPP_DownConvSize(down_conv);
     int elements;
 
@@ -8969,19 +8993,19 @@
 
     switch(size) {
         case 1:
-            dstB = (char *) m;
+            dstB = (_LPP_Char *) m;
             for (int i=0; i < elements; i++) {
                 dstB[i] = _LPP_DownConvByte(p2[i], down_conv);
             }
         break;
         case 2:
-            dstW = (short *) m;
+            dstW = (_LPP_Short *) m;
             for (int i=0; i < elements; i++) {
                 dstW[i] = _LPP_DownConvWord(p2[i], down_conv);
             }
         break;
         case 4:
-            dstD = (int *) m;
+            dstD = (_LPP_Int *) m;
             for (int i=0; i < elements; i++) {
                 dstD[i] = p2[i];
             }
@@ -8992,10 +9016,10 @@
 /* Store doubleword vector under mask. */
 inline void _mm512_mask_stored(void *m, __mmask k1, _M512 v2, _MM_DOWNCONV32_ENUM down_conv, _MM_STORE_SUBSET32_ENUM subset, _MM_MEM_HINT_ENUM)
 {
-    int *p2 = (int *) &v2;
-    char *dstB;
-    short *dstW;
-    int *dstD;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Char *dstB;
+    _LPP_Short *dstW;
+    _LPP_Int *dstD;
     int size = _LPP_DownConvSize(down_conv);
     int elements;
 
@@ -9005,7 +9029,7 @@
 
     switch(size) {
         case 1:
-            dstB = (char *) m;
+            dstB = (_LPP_Char *) m;
             for (int i=0; i < elements; i++) {
                 if (k1 & 1) {
                     dstB[i] = _LPP_DownConvByte(p2[i], down_conv);
@@ -9014,7 +9038,7 @@
             }
         break;
         case 2:
-            dstW = (short *) m;
+            dstW = (_LPP_Short *) m;
             for (int i=0; i < elements; i++) {
                 if (k1 & 1) {
                     dstW[i] = _LPP_DownConvWord(p2[i], down_conv);
@@ -9023,7 +9047,7 @@
             }
         break;
         case 4:
-            dstD = (int *) m;
+            dstD = (_LPP_Int *) m;
             for (int i=0; i < elements; i++) {
                 if (k1 & 1) {
                     dstD[i] = p2[i];
@@ -9037,8 +9061,8 @@
 /* Store quadword vector. */
 inline void _mm512_storeq(void *m, _M512 v2, _MM_DOWNCONV64_ENUM, _MM_STORE_SUBSET64_ENUM subset, _MM_MEM_HINT_ENUM)
 {
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *dst = (int64_t *) m;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *dst = (_LPP_Int64 *) m;
     int elements;
 
     if (subset == _MM_SUBSET64_8) elements = 8;
@@ -9053,8 +9077,8 @@
 /* Store quadword vector under mask. */
 inline void _mm512_mask_storeq(void *m, __mmask k1, _M512 v2, _MM_DOWNCONV64_ENUM, _MM_STORE_SUBSET64_ENUM subset, _MM_MEM_HINT_ENUM)
 {
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *dst = (int64_t *) m;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *dst = (_LPP_Int64 *) m;
     int elements;
 
     if (subset == _MM_SUBSET64_8) elements = 8;
@@ -9075,9 +9099,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = p2[i] - p3[i];
@@ -9100,10 +9124,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -9137,9 +9161,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] - p3[i];
@@ -9162,10 +9186,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -9199,9 +9223,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] - p3[i];
@@ -9224,10 +9248,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -9297,9 +9321,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p3[i] - p1[i];
